Index: src/CodeGen/CodeGenerator.cc
===================================================================
--- src/CodeGen/CodeGenerator.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/CodeGen/CodeGenerator.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Fri Jun 26 16:52:58 2015
-// Update Count     : 144
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Jul 15 14:47:42 2015
+// Update Count     : 177
 //
 
@@ -38,5 +38,5 @@
 	int CodeGenerator::tabsize = 4;
 
-	// the kinds of statements that would ideally be separated by more whitespace
+	// the kinds of statements that would ideally be followed by whitespace
 	bool wantSpacing( Statement * stmt) {
 		return dynamic_cast< IfStmt * >( stmt ) || dynamic_cast< CompoundStmt * >( stmt ) ||
@@ -588,11 +588,8 @@
 
 	void CodeGenerator::visit( ForStmt *forStmt ) {
-		output << "for (";
-
-		if ( forStmt->get_initialization() != 0 )
-			forStmt->get_initialization()->accept( *this );
-		else
-			output << ";";
-		
+		// initialization is always hoisted, so don't 
+		// bother doing anything with that 
+		output << "for (;";
+
 		if ( forStmt->get_condition() != 0 )
 			forStmt->get_condition()->accept( *this );
Index: src/CodeGen/GenType.cc
===================================================================
--- src/CodeGen/GenType.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/CodeGen/GenType.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Rob Schluntz
-// Last Modified On : Wed Jul 08 16:08:24 2015
-// Update Count     : 10
+// Last Modified By : Peter A. Buhr
+// Last Modified On : Thu Jul  9 16:43:52 2015
+// Update Count     : 13
 //
 
@@ -93,10 +93,12 @@
 			os << "_Atomic ";
 		} // if
+		if ( qualifiers.isAttribute ) {
+			os << "__attribute(( )) ";
+		} // if
 		if ( dimension != 0 ) {
 			CodeGenerator cg( os );
 			dimension->accept( cg );
 		} else if ( isVarLen ) {
-			// no dimension expression on a VLA
-			// means it came in with the * token
+			// no dimension expression on a VLA means it came in with the * token
 			os << "*";
 		} // if
@@ -202,4 +204,7 @@
 			typeString = "_Atomic " + typeString;
 		} // if
+		if ( type->get_isAttribute() ) {
+			typeString = "__attribute(( )) " + typeString;
+		} // if
 	}
 } // namespace CodeGen
Index: src/ControlStruct/ForExprMutator.cc
===================================================================
--- src/ControlStruct/ForExprMutator.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/ControlStruct/ForExprMutator.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Rodolfo G. Esteves
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Tue May 19 15:31:47 2015
-// Update Count     : 2
+// Last Modified By : Rob Schluntz
+// Last Modified On : Tue Jul 14 12:14:44 2015
+// Update Count     : 10
 //
 
@@ -22,15 +22,21 @@
 		// recurse down all nest for loops to hoist any initializer declarations to make them C89 (rather than C99)
 		forStmt->set_body( forStmt->get_body()->acceptMutator( *this ) );
-		if ( DeclStmt *decl = dynamic_cast< DeclStmt * > ( forStmt->get_initialization() ) ) {
-			// create compound statement, move initializer declaration outside, leave _for_ as-is
-			CompoundStmt *block = new CompoundStmt( std::list< Label >() );
-			std::list<Statement *> &stmts = block->get_kids();
 
-			stmts.push_back( decl );
-			forStmt->set_initialization( 0 );
-			stmts.push_back( forStmt );
+		std::list<Statement *> &init = forStmt->get_initialization(); 
+		if ( init.size() == 0 ) {
+			return forStmt;
+		} // if
 
-			return block;
-		} // if
+		// create compound statement, move initializers outside, leave _for_ as-is
+		CompoundStmt *block = new CompoundStmt( std::list< Label >() );
+		std::list<Statement *> &stmts = block->get_kids();
+		for ( std::list<Statement *>::iterator it = init.begin(); it != init.end(); ++it ) {
+			stmts.push_back( *it );
+		}	// for
+
+		// add for to the new block
+		stmts.push_back( forStmt );
+		forStmt->set_initialization( std::list<Statement *>() );
+		return block;
 
 		return forStmt;
Index: src/ControlStruct/MLEMutator.cc
===================================================================
--- src/ControlStruct/MLEMutator.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/ControlStruct/MLEMutator.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,7 +10,14 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Rob Schluntz
-// Last Modified On : Sat Jun 27 10:56:14 2015
-// Update Count     : 174
-//
+// Last Modified On : Mon Jul 20 13:58:35 2015
+// Update Count     : 176
+//
+
+// NOTE: There are two known subtle differences from the code that uC++ 
+// generates for the same input
+// -CFA puts the break label inside at the end of a switch, uC++ puts it after
+// -CFA puts the break label after a block, uC++ puts it inside at the end
+// we don't yet know if these differences are important, but if they are then
+// the fix would go in this file, since this is where these labels are generated.
 
 #include <cassert>
Index: src/ControlStruct/Mutate.cc
===================================================================
--- src/ControlStruct/Mutate.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/ControlStruct/Mutate.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Mon May 18 07:44:20 2015
 // Last Modified By : Rob Schluntz
-// Last Modified On : Wed Jun 03 23:08:43 2015
-// Update Count     : 5
+// Last Modified On : Wed Jul 15 14:50:04 2015
+// Update Count     : 7
 //
 
@@ -36,5 +36,6 @@
 namespace ControlStruct {
 	void mutate( std::list< Declaration * > translationUnit ) {
-		// ForExprMutator formut;
+		// hoist initialization out of for statements
+		ForExprMutator formut;
 
 		// normalizes label definitions and generates multi-level
@@ -51,5 +52,5 @@
 		// LabelTypeChecker lbl;
 
-		// mutateAll( translationUnit, formut );
+		mutateAll( translationUnit, formut );
 		acceptAll( translationUnit, lfix );
 		mutateAll( translationUnit, chmut );
Index: src/GenPoly/PolyMutator.cc
===================================================================
--- src/GenPoly/PolyMutator.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/GenPoly/PolyMutator.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Richard C. Bilson
 // Created On       : Mon May 18 07:44:20 2015
-// Last Modified By : Peter A. Buhr
-// Last Modified On : Tue May 19 07:45:50 2015
-// Update Count     : 1
+// Last Modified By : Rob Schluntz
+// Last Modified On : Wed Jul 15 14:50:58 2015
+// Update Count     : 3
 //
 
@@ -92,5 +92,5 @@
 	Statement * PolyMutator::mutate(ForStmt *forStmt) {
 		forStmt->set_body(  mutateStatement( forStmt->get_body() ) );
-		forStmt->set_initialization(  maybeMutate( forStmt->get_initialization(), *this ) );
+		mutateAll( forStmt->get_initialization(), *this );
 		forStmt->set_condition(  mutateExpression( forStmt->get_condition() ) );
 		forStmt->set_increment(  mutateExpression( forStmt->get_increment() ) );
Index: src/Parser/DeclarationNode.cc
===================================================================
--- src/Parser/DeclarationNode.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/Parser/DeclarationNode.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -9,7 +9,7 @@
 // Author           : Rodolfo G. Esteves
 // Created On       : Sat May 16 12:34:05 2015
-// Last Modified By : Rob Schluntz
-// Last Modified On : Wed Jul 08 16:40:37 2015
-// Update Count     : 121
+// Last Modified By : Peter A. Buhr
+// Last Modified On : Tue Jul 14 14:46:32 2015
+// Update Count     : 126
 //
 
@@ -472,6 +472,5 @@
 		if ( o->get_link() ) {
 			set_link( o->get_link()->clone() );
-		}
-
+		} // if
 	} // if
 	delete o;
Index: src/Parser/ParseNode.h
===================================================================
--- src/Parser/ParseNode.h	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/Parser/ParseNode.h	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Sat May 16 13:28:16 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Thu Jul  2 17:57:05 2015
-// Update Count     : 84
+// Last Modified On : Tue Jul 14 14:58:25 2015
+// Update Count     : 91
 //
 
@@ -265,5 +265,5 @@
 class DeclarationNode : public ParseNode {
   public:
-	enum Qualifier { Const, Restrict, Volatile, Lvalue, Atomic, Attribute };
+	enum Qualifier { Const, Restrict, Volatile, Lvalue, Atomic };
 	enum StorageClass { Extern, Static, Auto, Register, Inline, Fortran, Noreturn, Threadlocal, NoStorageClass, };
 	enum BasicType { Char, Int, Float, Double, Void, Bool, Complex, Imaginary };
@@ -352,4 +352,5 @@
 	std::string name;
 	std::list< StorageClass > storageClasses;
+	std::list< std::string > attributes;
 	ExpressionNode *bitfieldWidth;
 	InitializerNode *initializer;
@@ -358,5 +359,5 @@
 
 	static UniqueName anonymous;
-};
+}; // DeclarationNode
 
 class StatementNode : public ParseNode {
@@ -380,13 +381,14 @@
 	static StatementNode *newCatchStmt( DeclarationNode *d = 0, StatementNode *s = 0, bool catchRestP = false );
 
-	void set_control( ExpressionNode * );
-	StatementNode * set_block( StatementNode * );
-
-	ExpressionNode *get_control() const ;
-	StatementNode *get_block() const;
-	StatementNode::Type get_type() const;
+	StatementNode *set_block( StatementNode *b ) {	block = b; return this; }
+	StatementNode *get_block() const { return block; }
+
+	void set_control( ExpressionNode *c ) { control = c; }
+	ExpressionNode *get_control() const { return control; }
+
+	StatementNode::Type get_type() const { return type; }
 
 	StatementNode *add_label( const std::string * );
-	std::list<std::string> *get_labels() const;
+	const std::list<std::string> &get_labels() const { return labels; }
 
 	void addDeclaration( DeclarationNode *newDecl ) { decl = newDecl; }
@@ -409,10 +411,10 @@
 	ExpressionNode *control;
 	StatementNode *block;
-	std::list<std::string> *labels;
+	std::list<std::string> labels;
 	std::string *target;				// target label for jump statements
 	DeclarationNode *decl;
 
 	bool isCatchRest;
-};
+}; // StatementNode
 
 class CompoundStmtNode : public StatementNode {
Index: src/Parser/StatementNode.cc
===================================================================
--- src/Parser/StatementNode.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/Parser/StatementNode.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Sat May 16 14:59:41 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sat Jun  6 23:25:41 2015
-// Update Count     : 19
+// Last Modified On : Thu Jul 16 16:20:24 2015
+// Update Count     : 30
 //
 
@@ -72,5 +72,4 @@
 	delete control;
 	delete block;
-	delete labels;
 	delete target;
 	delete decl;
@@ -103,38 +102,11 @@
 }
 
-void StatementNode::set_control( ExpressionNode *c ) {
-	control = c;
-}
-
-StatementNode * StatementNode::set_block( StatementNode *b ) {
-	block = b;
-
-	return this;
-}
-
-ExpressionNode *StatementNode::get_control() const {
-	return control;
-}
-
-StatementNode *StatementNode::get_block() const {
-	return block;
-}
-
-StatementNode::Type StatementNode::get_type() const {
-	return type;
-}
-
 StatementNode *StatementNode::add_label( const std::string *l ) {
 	if ( l != 0 ) {
-		if ( labels == 0 )
-			labels = new std::list<std::string>();
-
-		labels->push_front(*l ); 
+		labels.push_front( *l ); 
 		delete l;
 	} // if
 	return this;
 }
-
-std::list<std::string> *StatementNode::get_labels() const { return labels; }
 
 StatementNode *StatementNode::add_controlexp( ExpressionNode *e ) {
@@ -170,13 +142,11 @@
 
 void StatementNode::print( std::ostream &os, int indent ) const {
-	if ( labels != 0 ) {
-		if ( ! labels->empty()) {
-			std::list<std::string>::const_iterator i;
-
-			os << string( indent, ' ' );
-			for ( i = labels->begin(); i != labels->end(); i++ )
-				os << *i << ":";
-			os << endl;
-		} // if
+	if ( ! labels.empty()) {
+		std::list<std::string>::const_iterator i;
+
+		os << string( indent, ' ' );
+		for ( i = labels.begin(); i != labels.end(); i++ )
+			os << *i << ":";
+		os << endl;
 	} // if
 
@@ -225,7 +195,7 @@
 	std::list<Label> labs;
 
-	if ( labels != 0 ) {
+	if ( ! labels.empty() ) {
 		std::back_insert_iterator< std::list<Label> > lab_it( labs );
-		copy( labels->begin(), labels->end(), lab_it );
+		copy( labels.begin(), labels.end(), lab_it );
 	} // if
 
@@ -271,7 +241,8 @@
 			assert( ctl != 0 );
 
-			Statement *stmt = 0;
-			if ( ctl->get_init() != 0 )
-				stmt = ctl->get_init()->build();
+			std::list<Statement *> init;
+			if ( ctl->get_init() != 0 ) {
+				buildList( ctl->get_init(), init );
+			} // if
 
 			Expression *cond = 0;
@@ -283,5 +254,5 @@
 				incr = ctl->get_change()->build();
 
-			return new ForStmt( labs, stmt, cond, incr, branches.front() );
+			return new ForStmt( labs, init, cond, incr, branches.front() );
 		}
 	  case Switch:
@@ -377,9 +348,9 @@
 Statement *CompoundStmtNode::build() const {
 	std::list<Label> labs;
-	std::list<std::string> *labels = get_labels();
-
-	if ( labels != 0 ) {
+	const std::list<std::string> &labels = get_labels();
+
+	if ( ! labels.empty() ) {
 		std::back_insert_iterator< std::list<Label> > lab_it( labs );
-		copy( labels->begin(), labels->end(), lab_it );
+		copy( labels.begin(), labels.end(), lab_it );
 	} // if
 
Index: src/Parser/TypeData.cc
===================================================================
--- src/Parser/TypeData.cc	(revision 1e8f14363888febd56c5b6f87d7874191e24fd45)
+++ src/Parser/TypeData.cc	(revision b29f8f30a4ca0a0f8e240002265e2de95e57588a)
@@ -10,6 +10,6 @@
 // Created On       : Sat May 16 15:12:51 2015
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Fri Jun 26 07:30:06 2015
-// Update Count     : 26
+// Last Modified On : Tue Jul 14 14:57:23 2015
+// Update Count     : 32
 //
 
@@ -397,4 +397,7 @@
 		} // if
 		break;
+	  default:
+		os << "internal error: TypeData::print " << kind  << endl;
+		assert( false );
 	} // switch
 }
@@ -474,9 +477,5 @@
 		return buildVariable();
 	} else {
-		if ( isInline || isNoreturn ) {
-			throw SemanticError( "invalid inline or _Noreturn specification in declaration of ", this );
-		} else {
-			return new ObjectDecl( name, sc, linkage, bitfieldWidth, build(), init );
-		} // if
+		return new ObjectDecl( name, sc, linkage, bitfieldWidth, build(), init, isInline, isNoreturn );
 	} // if
 	return 0;
@@ -536,7 +535,4 @@
 		  case DeclarationNode::Atomic:
 			q.isAtomic = true;
-			break;
-		  case DeclarationNode::Attribute:
-			q.isAttribute = true;
 			break;
 		} // switch
